<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Tower Attack: CAttacker Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Tower Attack
   </div>
   <div id="projectbrief">A simple console game</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="#friends">Friends</a> &#124;
<a href="classCAttacker-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">CAttacker Class Reference<span class="mlabels"><span class="mlabel">abstract</span></span></div>  </div>
</div><!--header-->
<div class="contents">

<p>Attacker is one of the main game objects, it can attack and defend itself from other towers, it remembers it's position, can save itself to a file, move itself and clones itself.  
 <a href="classCAttacker.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="entities_8h_source.html">entities.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for CAttacker:</div>
<div class="dyncontent">
<div class="center"><img src="classCAttacker__inherit__graph.png" border="0" usemap="#CAttacker_inherit__map" alt="Inheritance graph"/></div>
<map name="CAttacker_inherit__map" id="CAttacker_inherit__map">
<area shape="rect" id="node3" href="classCArcher.html" title="Archer 50% chance of extending range by half, 10 % chance of attacking twice. " alt="" coords="5,155,76,181"/>
<area shape="rect" id="node4" href="classCMage.html" title="Mage 50% chance of attacking twice, 10% chance of blocking attack from medic, 10% chance of getting s..." alt="" coords="101,155,165,181"/>
<area shape="rect" id="node5" href="classCWarrior.html" title="Warrior 33% chance of blocking attack from artillery, 10 % chance of attacking twice. " alt="" coords="189,155,263,181"/>
<area shape="rect" id="node2" href="classCEntity.html" title="Abstract class, used to store entities to map. " alt="" coords="99,5,166,32"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<div class="dynheader">
Collaboration diagram for CAttacker:</div>
<div class="dyncontent">
<div class="center"><img src="classCAttacker__coll__graph.png" border="0" usemap="#CAttacker_coll__map" alt="Collaboration graph"/></div>
<map name="CAttacker_coll__map" id="CAttacker_coll__map">
<area shape="rect" id="node2" href="classCEntity.html" title="Abstract class, used to store entities to map. " alt="" coords="5,5,72,32"/>
<area shape="rect" id="node3" href="structTCoord.html" title="Coordinates, row and col. " alt="" coords="97,5,162,32"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a5173f06a05a13aaedbc922dfd5379ba8"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCAttacker.html#a5173f06a05a13aaedbc922dfd5379ba8">CAttacker</a> (char <a class="el" href="classCAttacker.html#a7b0fb16fc8285e01ee8f7cedc5343571">symbol</a>, const string &amp;name, int hp, int <a class="el" href="classCAttacker.html#ab80d734314eeb349e86931d2d50289d9">attack</a>, int range, int <a class="el" href="classCAttacker.html#a84a16391de74e89f0cbba0b134f1cd90">speed</a>, int parentID)</td></tr>
<tr class="memdesc:a5173f06a05a13aaedbc922dfd5379ba8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Attacker constructor, sets member variables.  <a href="#a5173f06a05a13aaedbc922dfd5379ba8">More...</a><br /></td></tr>
<tr class="separator:a5173f06a05a13aaedbc922dfd5379ba8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6887b2124aa6480e067bbf928a718142"><td class="memItemLeft" align="right" valign="top"><a id="a6887b2124aa6480e067bbf928a718142"></a>
virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCAttacker.html#a6887b2124aa6480e067bbf928a718142">print</a> (ostream &amp;os) const</td></tr>
<tr class="memdesc:a6887b2124aa6480e067bbf928a718142"><td class="mdescLeft">&#160;</td><td class="mdescRight">virtual destructor <br /></td></tr>
<tr class="separator:a6887b2124aa6480e067bbf928a718142"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa67f5bd7e030fc3b93b3f4e6891f0477"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCAttacker.html#aa67f5bd7e030fc3b93b3f4e6891f0477">printDetails</a> (ostream &amp;os) const</td></tr>
<tr class="memdesc:aa67f5bd7e030fc3b93b3f4e6891f0477"><td class="mdescLeft">&#160;</td><td class="mdescRight">prints attacker's symbol  <a href="#aa67f5bd7e030fc3b93b3f4e6891f0477">More...</a><br /></td></tr>
<tr class="separator:aa67f5bd7e030fc3b93b3f4e6891f0477"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a317e10be6678348685f76eca1aa2e67f"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCAttacker.html#a317e10be6678348685f76eca1aa2e67f">setPath</a> (const list&lt; <a class="el" href="structTCoord.html">TCoord</a> &gt; &amp;path)</td></tr>
<tr class="memdesc:a317e10be6678348685f76eca1aa2e67f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets path to attacker.  <a href="#a317e10be6678348685f76eca1aa2e67f">More...</a><br /></td></tr>
<tr class="separator:a317e10be6678348685f76eca1aa2e67f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad169c0c3b122289339d5c9c11f6dd2f1"><td class="memItemLeft" align="right" valign="top"><a id="ad169c0c3b122289339d5c9c11f6dd2f1"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>setEntrance</b> (int entranceIdx)</td></tr>
<tr class="separator:ad169c0c3b122289339d5c9c11f6dd2f1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac99d568c2cdce5d0c35b42bf16d9302f"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCAttacker.html#ac99d568c2cdce5d0c35b42bf16d9302f">move</a> ()</td></tr>
<tr class="memdesc:ac99d568c2cdce5d0c35b42bf16d9302f"><td class="mdescLeft">&#160;</td><td class="mdescRight">sets entrance ID  <a href="#ac99d568c2cdce5d0c35b42bf16d9302f">More...</a><br /></td></tr>
<tr class="separator:ac99d568c2cdce5d0c35b42bf16d9302f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abc8bae44906274f3340bc91858367ead"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCAttacker.html#abc8bae44906274f3340bc91858367ead">save</a> (ofstream &amp;ofs) const</td></tr>
<tr class="memdesc:abc8bae44906274f3340bc91858367ead"><td class="mdescLeft">&#160;</td><td class="mdescRight">Save attacker to stream given by parameter.  <a href="#abc8bae44906274f3340bc91858367ead">More...</a><br /></td></tr>
<tr class="separator:abc8bae44906274f3340bc91858367ead"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad3f22ead3302344cc23defe93994e6db"><td class="memItemLeft" align="right" valign="top"><a class="el" href="structTCoord.html">TCoord</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCAttacker.html#ad3f22ead3302344cc23defe93994e6db">nextMove</a> (int maxSpeed)</td></tr>
<tr class="memdesc:ad3f22ead3302344cc23defe93994e6db"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the next position where attacker is heading, if it has moved m_speed times and the map speed is faster, it doesn't move and returns current position.  <a href="#ad3f22ead3302344cc23defe93994e6db">More...</a><br /></td></tr>
<tr class="separator:ad3f22ead3302344cc23defe93994e6db"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acc2378e8d89ff78fc775492a7b2daa86"><td class="memItemLeft" align="right" valign="top"><a id="acc2378e8d89ff78fc775492a7b2daa86"></a>
<a class="el" href="structTCoord.html">TCoord</a>&#160;</td><td class="memItemRight" valign="bottom"><b>position</b> () const</td></tr>
<tr class="separator:acc2378e8d89ff78fc775492a7b2daa86"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7b0fb16fc8285e01ee8f7cedc5343571"><td class="memItemLeft" align="right" valign="top"><a id="a7b0fb16fc8285e01ee8f7cedc5343571"></a>
char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCAttacker.html#a7b0fb16fc8285e01ee8f7cedc5343571">symbol</a> () const</td></tr>
<tr class="memdesc:a7b0fb16fc8285e01ee8f7cedc5343571"><td class="mdescLeft">&#160;</td><td class="mdescRight">setter for position of the attacker <br /></td></tr>
<tr class="separator:a7b0fb16fc8285e01ee8f7cedc5343571"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a84a16391de74e89f0cbba0b134f1cd90"><td class="memItemLeft" align="right" valign="top"><a id="a84a16391de74e89f0cbba0b134f1cd90"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCAttacker.html#a84a16391de74e89f0cbba0b134f1cd90">speed</a> () const</td></tr>
<tr class="memdesc:a84a16391de74e89f0cbba0b134f1cd90"><td class="mdescLeft">&#160;</td><td class="mdescRight">getter for symbol of the attacker <br /></td></tr>
<tr class="separator:a84a16391de74e89f0cbba0b134f1cd90"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5d1bd8010d5f5628dd4a0bd8a973a3bb"><td class="memItemLeft" align="right" valign="top"><a id="a5d1bd8010d5f5628dd4a0bd8a973a3bb"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCAttacker.html#a5d1bd8010d5f5628dd4a0bd8a973a3bb">resetSpeedCnt</a> ()</td></tr>
<tr class="memdesc:a5d1bd8010d5f5628dd4a0bd8a973a3bb"><td class="mdescLeft">&#160;</td><td class="mdescRight">getter for speed of the attacker <br /></td></tr>
<tr class="separator:a5d1bd8010d5f5628dd4a0bd8a973a3bb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab80eeb5cfe0dc7ac9979a35a60cfb7c3"><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCAttacker.html#ab80eeb5cfe0dc7ac9979a35a60cfb7c3">hasInRange</a> (const <a class="el" href="structTCoord.html">TCoord</a> &amp;src) const</td></tr>
<tr class="memdesc:ab80eeb5cfe0dc7ac9979a35a60cfb7c3"><td class="mdescLeft">&#160;</td><td class="mdescRight">resets speed counter to 0  <a href="#ab80eeb5cfe0dc7ac9979a35a60cfb7c3">More...</a><br /></td></tr>
<tr class="separator:ab80eeb5cfe0dc7ac9979a35a60cfb7c3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a82ee1f8ecbb8754f223c2eba3cf799a3"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCAttacker.html#a82ee1f8ecbb8754f223c2eba3cf799a3">defend</a> (<a class="el" href="classCTower.html">CTower</a> &amp;src)</td></tr>
<tr class="memdesc:a82ee1f8ecbb8754f223c2eba3cf799a3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Default defend method of the attackers.  <a href="#a82ee1f8ecbb8754f223c2eba3cf799a3">More...</a><br /></td></tr>
<tr class="separator:a82ee1f8ecbb8754f223c2eba3cf799a3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa0b6e1fcbee3cb390d252d5f8c4474f7"><td class="memItemLeft" align="right" valign="top"><a id="aa0b6e1fcbee3cb390d252d5f8c4474f7"></a>
virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCAttacker.html#aa0b6e1fcbee3cb390d252d5f8c4474f7">defend</a> (<a class="el" href="classCMedic.html">CMedic</a> &amp;src)</td></tr>
<tr class="memdesc:aa0b6e1fcbee3cb390d252d5f8c4474f7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Default defend method against medic. <br /></td></tr>
<tr class="separator:aa0b6e1fcbee3cb390d252d5f8c4474f7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab80d734314eeb349e86931d2d50289d9"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCAttacker.html#ab80d734314eeb349e86931d2d50289d9">attack</a> (<a class="el" href="classCTower.html">CTower</a> &amp;dst)</td></tr>
<tr class="memdesc:ab80d734314eeb349e86931d2d50289d9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Default attack method of the attacker.  <a href="#ab80d734314eeb349e86931d2d50289d9">More...</a><br /></td></tr>
<tr class="separator:ab80d734314eeb349e86931d2d50289d9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a27352022dbe260beae06e7cd535062dc"><td class="memItemLeft" align="right" valign="top"><a id="a27352022dbe260beae06e7cd535062dc"></a>
virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCAttacker.html#a27352022dbe260beae06e7cd535062dc">defend</a> (<a class="el" href="classCArtillery.html">CArtillery</a> &amp;src)</td></tr>
<tr class="memdesc:a27352022dbe260beae06e7cd535062dc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Default defend method against artillery. <br /></td></tr>
<tr class="separator:a27352022dbe260beae06e7cd535062dc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6151f85fde51772b9034bee6f3cf0b37"><td class="memItemLeft" align="right" valign="top"><a id="a6151f85fde51772b9034bee6f3cf0b37"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><b>getAttack</b> () const</td></tr>
<tr class="separator:a6151f85fde51772b9034bee6f3cf0b37"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2fda02cade366510afb500d22143b558"><td class="memItemLeft" align="right" valign="top"><a id="a2fda02cade366510afb500d22143b558"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCAttacker.html#a2fda02cade366510afb500d22143b558">getHp</a> () const</td></tr>
<tr class="memdesc:a2fda02cade366510afb500d22143b558"><td class="mdescLeft">&#160;</td><td class="mdescRight">getter for attack strength <br /></td></tr>
<tr class="separator:a2fda02cade366510afb500d22143b558"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab8640dff4a1129c25c59af1f217995fb"><td class="memItemLeft" align="right" valign="top"><a id="ab8640dff4a1129c25c59af1f217995fb"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCAttacker.html#ab8640dff4a1129c25c59af1f217995fb">setHp</a> (int hp)</td></tr>
<tr class="memdesc:ab8640dff4a1129c25c59af1f217995fb"><td class="mdescLeft">&#160;</td><td class="mdescRight">getter for health <br /></td></tr>
<tr class="separator:ab8640dff4a1129c25c59af1f217995fb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abf388fe012f5703cd33ed2b17a0f8415"><td class="memItemLeft" align="right" valign="top"><a id="abf388fe012f5703cd33ed2b17a0f8415"></a>
virtual <a class="el" href="classCAttacker.html">CAttacker</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCAttacker.html#abf388fe012f5703cd33ed2b17a0f8415">clone</a> () const =0</td></tr>
<tr class="memdesc:abf388fe012f5703cd33ed2b17a0f8415"><td class="mdescLeft">&#160;</td><td class="mdescRight">setter for health <br /></td></tr>
<tr class="separator:abf388fe012f5703cd33ed2b17a0f8415"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classCEntity"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classCEntity')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classCEntity.html">CEntity</a></td></tr>
<tr class="memitem:a9ab2d129368e2d3acfec883129439e1c inherit pub_methods_classCEntity"><td class="memItemLeft" align="right" valign="top"><a id="a9ab2d129368e2d3acfec883129439e1c"></a>
virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCEntity.html#a9ab2d129368e2d3acfec883129439e1c">discover</a> () const</td></tr>
<tr class="memdesc:a9ab2d129368e2d3acfec883129439e1c inherit pub_methods_classCEntity"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns whether the field is discoverable ( if it's either free space or path ) <br /></td></tr>
<tr class="separator:a9ab2d129368e2d3acfec883129439e1c inherit pub_methods_classCEntity"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5bedcc5d44f5b4a65d8abd8bc7766588 inherit pub_methods_classCEntity"><td class="memItemLeft" align="right" valign="top"><a id="a5bedcc5d44f5b4a65d8abd8bc7766588"></a>
virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCEntity.html#a5bedcc5d44f5b4a65d8abd8bc7766588">isPath</a> () const</td></tr>
<tr class="memdesc:a5bedcc5d44f5b4a65d8abd8bc7766588 inherit pub_methods_classCEntity"><td class="mdescLeft">&#160;</td><td class="mdescRight">Prints the object ( it's symbol ) <br /></td></tr>
<tr class="separator:a5bedcc5d44f5b4a65d8abd8bc7766588 inherit pub_methods_classCEntity"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a833f1423fd7e0f2096517b100c44db72 inherit pub_methods_classCEntity"><td class="memItemLeft" align="right" valign="top"><a id="a833f1423fd7e0f2096517b100c44db72"></a>
virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCEntity.html#a833f1423fd7e0f2096517b100c44db72">~CEntity</a> ()=default</td></tr>
<tr class="memdesc:a833f1423fd7e0f2096517b100c44db72 inherit pub_methods_classCEntity"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns whether the field is path or not. <br /></td></tr>
<tr class="separator:a833f1423fd7e0f2096517b100c44db72 inherit pub_methods_classCEntity"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:afa3a9b9cd0d07c81517c19297d1a82d8"><td class="memItemLeft" align="right" valign="top"><a id="afa3a9b9cd0d07c81517c19297d1a82d8"></a>
<a class="el" href="structTCoord.html">TCoord</a>&#160;</td><td class="memItemRight" valign="bottom"><b>m_pos</b></td></tr>
<tr class="separator:afa3a9b9cd0d07c81517c19297d1a82d8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa48a189c978311cf04fa6f99c98c8214"><td class="memItemLeft" align="right" valign="top"><a id="aa48a189c978311cf04fa6f99c98c8214"></a>
list&lt; <a class="el" href="structTCoord.html">TCoord</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><b>m_pathToEnd</b></td></tr>
<tr class="separator:aa48a189c978311cf04fa6f99c98c8214"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aba8a93ffda4d7e3232159abc7cbf1c6a"><td class="memItemLeft" align="right" valign="top"><a id="aba8a93ffda4d7e3232159abc7cbf1c6a"></a>
list&lt; <a class="el" href="structTCoord.html">TCoord</a> &gt;::const_iterator&#160;</td><td class="memItemRight" valign="bottom"><b>m_pathIt</b></td></tr>
<tr class="separator:aba8a93ffda4d7e3232159abc7cbf1c6a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af8df1fa17340f9992421dabf58c532c9"><td class="memItemLeft" align="right" valign="top"><a id="af8df1fa17340f9992421dabf58c532c9"></a>
char&#160;</td><td class="memItemRight" valign="bottom"><b>m_symbol</b></td></tr>
<tr class="separator:af8df1fa17340f9992421dabf58c532c9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad0cdbce1ccb67d6bb33fa2a365492ffd"><td class="memItemLeft" align="right" valign="top"><a id="ad0cdbce1ccb67d6bb33fa2a365492ffd"></a>
string&#160;</td><td class="memItemRight" valign="bottom"><b>m_name</b></td></tr>
<tr class="separator:ad0cdbce1ccb67d6bb33fa2a365492ffd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad53bbe35233105ba5770fc7962beaede"><td class="memItemLeft" align="right" valign="top"><a id="ad53bbe35233105ba5770fc7962beaede"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><b>m_hp</b></td></tr>
<tr class="separator:ad53bbe35233105ba5770fc7962beaede"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a94e22b914a91e8d78a81abf681499289"><td class="memItemLeft" align="right" valign="top"><a id="a94e22b914a91e8d78a81abf681499289"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><b>m_attack</b></td></tr>
<tr class="separator:a94e22b914a91e8d78a81abf681499289"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8cb8c0ee70d9ce5770a8206e6b004b47"><td class="memItemLeft" align="right" valign="top"><a id="a8cb8c0ee70d9ce5770a8206e6b004b47"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><b>m_range</b></td></tr>
<tr class="separator:a8cb8c0ee70d9ce5770a8206e6b004b47"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af26e963ac52a623ae9c3346363e9fe7c"><td class="memItemLeft" align="right" valign="top"><a id="af26e963ac52a623ae9c3346363e9fe7c"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><b>m_speed</b></td></tr>
<tr class="separator:af26e963ac52a623ae9c3346363e9fe7c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af6b63d8b2559885bc92b99de25f4bf22"><td class="memItemLeft" align="right" valign="top"><a id="af6b63d8b2559885bc92b99de25f4bf22"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><b>m_speedCnt</b></td></tr>
<tr class="separator:af6b63d8b2559885bc92b99de25f4bf22"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad01a568a6fc0e581e0c8aedbb2f98f5d"><td class="memItemLeft" align="right" valign="top"><a id="ad01a568a6fc0e581e0c8aedbb2f98f5d"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><b>m_parentID</b></td></tr>
<tr class="separator:ad01a568a6fc0e581e0c8aedbb2f98f5d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1cfa0704fb19a72ea01e3f6bce1ecdd5"><td class="memItemLeft" align="right" valign="top"><a id="a1cfa0704fb19a72ea01e3f6bce1ecdd5"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><b>m_steps</b></td></tr>
<tr class="separator:a1cfa0704fb19a72ea01e3f6bce1ecdd5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac72ed558981fd8be20021a00fe0b1ea3"><td class="memItemLeft" align="right" valign="top"><a id="ac72ed558981fd8be20021a00fe0b1ea3"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><b>m_entranceID</b></td></tr>
<tr class="separator:ac72ed558981fd8be20021a00fe0b1ea3"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="friends"></a>
Friends</h2></td></tr>
<tr class="memitem:a2e6cbcd2b80ad9fc8efd1251b9b2fb9d"><td class="memItemLeft" align="right" valign="top">ostream &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCAttacker.html#a2e6cbcd2b80ad9fc8efd1251b9b2fb9d">operator&lt;&lt;</a> (ostream &amp;os, const <a class="el" href="classCAttacker.html">CAttacker</a> &amp;attacker)</td></tr>
<tr class="memdesc:a2e6cbcd2b80ad9fc8efd1251b9b2fb9d"><td class="mdescLeft">&#160;</td><td class="mdescRight">virtual clone method  <a href="#a2e6cbcd2b80ad9fc8efd1251b9b2fb9d">More...</a><br /></td></tr>
<tr class="separator:a2e6cbcd2b80ad9fc8efd1251b9b2fb9d"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Attacker is one of the main game objects, it can attack and defend itself from other towers, it remembers it's position, can save itself to a file, move itself and clones itself. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a5173f06a05a13aaedbc922dfd5379ba8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5173f06a05a13aaedbc922dfd5379ba8">&#9670;&nbsp;</a></span>CAttacker()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">CAttacker::CAttacker </td>
          <td>(</td>
          <td class="paramtype">char&#160;</td>
          <td class="paramname"><em>symbol</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const string &amp;&#160;</td>
          <td class="paramname"><em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>hp</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>attack</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>range</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>speed</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>parentID</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Attacker constructor, sets member variables. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">symbol</td><td></td></tr>
    <tr><td class="paramname">name</td><td></td></tr>
    <tr><td class="paramname">hp</td><td>health </td></tr>
    <tr><td class="paramname">attack</td><td>how much damage can attacker cause </td></tr>
    <tr><td class="paramname">range</td><td>how far does he see </td></tr>
    <tr><td class="paramname">speed</td><td>how fast does he move </td></tr>
    <tr><td class="paramname">parentID</td><td>who is his template ( parent ) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="ab80d734314eeb349e86931d2d50289d9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab80d734314eeb349e86931d2d50289d9">&#9670;&nbsp;</a></span>attack()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void CAttacker::attack </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classCTower.html">CTower</a> &amp;&#160;</td>
          <td class="paramname"><em>dst</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Default attack method of the attacker. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">dst</td><td>Attacker to attack </td></tr>
  </table>
  </dd>
</dl>

<p>Reimplemented in <a class="el" href="classCMage.html#a49df57d341e5e94d01ada32869ae3ac3">CMage</a>, <a class="el" href="classCArcher.html#a0cf04733e2e416705e83cb963a486811">CArcher</a>, and <a class="el" href="classCWarrior.html#a3b0227bb1bbd06ee84d51f08a4c9cc6c">CWarrior</a>.</p>

</div>
</div>
<a id="a82ee1f8ecbb8754f223c2eba3cf799a3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a82ee1f8ecbb8754f223c2eba3cf799a3">&#9670;&nbsp;</a></span>defend()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void CAttacker::defend </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classCTower.html">CTower</a> &amp;&#160;</td>
          <td class="paramname"><em>src</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Default defend method of the attackers. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">src</td><td>Tower that attacks this attacker </td></tr>
  </table>
  </dd>
</dl>

<p>Reimplemented in <a class="el" href="classCMage.html#a079a84f3d81071e53a046538dc603dff">CMage</a>.</p>

</div>
</div>
<a id="ab80eeb5cfe0dc7ac9979a35a60cfb7c3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab80eeb5cfe0dc7ac9979a35a60cfb7c3">&#9670;&nbsp;</a></span>hasInRange()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool CAttacker::hasInRange </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="structTCoord.html">TCoord</a> &amp;&#160;</td>
          <td class="paramname"><em>src</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>resets speed counter to 0 </p>
<p>Returns whether the given coordinates are in attacker's range.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">src</td><td>coordinates to compare </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>if the src coordinates are in range </dd></dl>

<p>Reimplemented in <a class="el" href="classCArcher.html#acddd397be7733c5bd58ab9067b2d5823">CArcher</a>.</p>

</div>
</div>
<a id="ac99d568c2cdce5d0c35b42bf16d9302f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac99d568c2cdce5d0c35b42bf16d9302f">&#9670;&nbsp;</a></span>move()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool CAttacker::move </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>sets entrance ID </p>
<p>Moves the attacker one step towards the exit.</p>
<dl class="section return"><dt>Returns</dt><dd>bool value if the attacker reached the end </dd></dl>

</div>
</div>
<a id="ad3f22ead3302344cc23defe93994e6db"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad3f22ead3302344cc23defe93994e6db">&#9670;&nbsp;</a></span>nextMove()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structTCoord.html">TCoord</a> CAttacker::nextMove </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>maxSpeed</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns the next position where attacker is heading, if it has moved m_speed times and the map speed is faster, it doesn't move and returns current position. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">maxSpeed</td><td>what is the current maximum speed </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>next position of the attacker </dd></dl>

</div>
</div>
<a id="aa67f5bd7e030fc3b93b3f4e6891f0477"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa67f5bd7e030fc3b93b3f4e6891f0477">&#9670;&nbsp;</a></span>printDetails()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void CAttacker::printDetails </td>
          <td>(</td>
          <td class="paramtype">ostream &amp;&#160;</td>
          <td class="paramname"><em>os</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>prints attacker's symbol </p>
<p>Prints attacker details to stream. </p>

<p>Reimplemented in <a class="el" href="classCMage.html#a442c6f6c9486817a89f6a3a31524fb83">CMage</a>, <a class="el" href="classCArcher.html#a75d02fd8d17cd797de726d6175331bbe">CArcher</a>, and <a class="el" href="classCWarrior.html#a34b880b9b1734a83c7ea7dc5040ebe4e">CWarrior</a>.</p>

</div>
</div>
<a id="abc8bae44906274f3340bc91858367ead"></a>
<h2 class="memtitle"><span class="permalink"><a href="#abc8bae44906274f3340bc91858367ead">&#9670;&nbsp;</a></span>save()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void CAttacker::save </td>
          <td>(</td>
          <td class="paramtype">ofstream &amp;&#160;</td>
          <td class="paramname"><em>ofs</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Save attacker to stream given by parameter. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">ofs</td><td>stream to save attacker into </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a317e10be6678348685f76eca1aa2e67f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a317e10be6678348685f76eca1aa2e67f">&#9670;&nbsp;</a></span>setPath()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void CAttacker::setPath </td>
          <td>(</td>
          <td class="paramtype">const list&lt; <a class="el" href="structTCoord.html">TCoord</a> &gt; &amp;&#160;</td>
          <td class="paramname"><em>path</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Sets path to attacker. </p>
<p>When he enters the map, he needs to know how to get to the end, so list of coordinates from the entrance he was inserted into is copied into his member value </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">path</td><td>to assign </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Friends And Related Function Documentation</h2>
<a id="a2e6cbcd2b80ad9fc8efd1251b9b2fb9d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2e6cbcd2b80ad9fc8efd1251b9b2fb9d">&#9670;&nbsp;</a></span>operator<<</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">ostream&amp; operator&lt;&lt; </td>
          <td>(</td>
          <td class="paramtype">ostream &amp;&#160;</td>
          <td class="paramname"><em>os</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classCAttacker.html">CAttacker</a> &amp;&#160;</td>
          <td class="paramname"><em>attacker</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">friend</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>virtual clone method </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">attacker</td><td>to print </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="entities_8h_source.html">entities.h</a></li>
<li>entities.cpp</li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
